package EDU.auburn.VGJ;


import org.omg.CORBA.*;
import java.net.URL;   
import java.net.MalformedURLException;
import java.io.*;

/**
 *  The GlobalConfig class. It provides global settings and variables to 
 *  other classes.
 *  </p>Here is the <a href="../VGJ.java">source</a>.
 *
**/
public class Config
{
	static private String host;
	static private org.omg.CORBA.ORB orb;
	static private String user_context;
        static private String master_name;
	static private WebFlow.WebFlowContext gateway;

	static void Init(org.omg.CORBA.ORB anORB, String aHost, String aUserContext, String aMasterName)
	{
	  orb = anORB;
	  host = new String(aHost);
	  user_context = new String(aUserContext);
	  master_name = new String(aMasterName);

	  String masterURL = host + "/IOR/QSmaster.txt"; //!!!!! change it
	  String ref = Config.getIORFromURL(masterURL);
	  if(ref == null) {
	      System.err.println("GlobalConfig: Failed to get gateway URL!");
	      throw new RuntimeException();
	  }
	  org.omg.CORBA.Object obj = orb.string_to_object(ref);
	  if(obj == null) {
	      System.err.println("GlobalConfig: Failed to convert gateway IOR to object!");
	      throw new RuntimeException();
	  }

	  gateway = WebFlow.WebFlowContextHelper.narrow(obj);
	  if(gateway == null) {
	      System.err.println("GlobalConfig: Failed to narrow gateway object!");
	      throw new RuntimeException();
	  }
	  System.out.println("Gateway object is successfully connected!");
	};

	static public String getHost() { return host; };

	static public org.omg.CORBA.ORB getORB() { return orb; };

	static public String getUserName() { return user_context; };

        static public String getMasterName() { return master_name; };

	static public WebFlow.WebFlowContext getGateway() { return gateway; };

	static public String getIORFromURL(String aURL)
	{
  	System.out.println("GlobalConfig.getIORFromFile is called for: " + aURL);
  	String IOR = "";
  	String thisLine=null;
  	try {
      URL url = new URL(aURL); //create URL java object
      DataInputStream theHTML = new DataInputStream(url.openStream());
      while ((thisLine = theHTML.readLine()) != null)
        IOR += thisLine;
      }
    catch (MalformedURLException e) {
      System.out.println("GlobalConfig.getIORFromURL: " + aURL + " is not a parseable URL");
      System.out.println("GlobalConfig.getIORFromURL: " + e);
      }
    catch (Exception e) {
	    System.out.println("GlobalConfig.getIORFromURL: " + e);
	    }
    return IOR;
  }

}
